--  2002 Peter Thiemann
module EventHandlers where

import HTMLWrapper

--abort
onAbort :: Monad m => String -> WithHTML x m ()
onAbort = attr "onAbort"
-- ^The user aborts the loading of an image (for example by clicking a link or
-- clicking the Stop button). 

--blur
onBlur :: Monad m => String -> WithHTML x m ()
onBlur = attr "onBlur"
-- ^A form element loses focus or when a window or frame loses focus.

--change
onChange :: Monad m => String -> WithHTML x m ()
onChange = attr "onChange"
-- ^A select, text, or textarea field loses focus and its value has been modified.

--click
onClick :: Monad m => String -> WithHTML x m ()
onClick = attr "onClick"
-- ^An object on a form is clicked.

--dblclick
onDblClick :: Monad m => String -> WithHTML x m ()
onDblClick = attr "onDblClick"
-- ^The user double-clicks a form element or a link.

--dragdrop
onDragDrop :: Monad m => String -> WithHTML x m ()
onDragDrop = attr "onDragDrop"
-- ^The user drops an object onto the browser window, such as dropping a file on
-- the browser window. 

--error
onError :: Monad m => String -> WithHTML x m ()
onError = attr "onError"
-- ^The loading of a document or image causes an error.

--focus
onFocus :: Monad m => String -> WithHTML x m ()
onFocus = attr "onFocus"
-- ^A window, frame, or frameset receives focus or when a form element receives
-- input focus. 

--keydown
onKeyDown :: Monad m => String -> WithHTML x m ()
onKeyDown = attr "onKeyDown"
-- ^The user depresses a key.

--keypress
onKeyPress :: Monad m => String -> WithHTML x m ()
onKeyPress = attr "onKeyPress"
-- ^The user presses or holds down a key.

--keyup
onKeyUp :: Monad m => String -> WithHTML x m ()
onKeyUp = attr "onKeyUp"
-- ^The user releases a key.

--load
onLoad :: Monad m => String -> WithHTML x m ()
onLoad = attr "onLoad"
-- ^The browser finishes loading a window or all of the frames within a FRAMESET tag.

--mousedown
onMouseDown :: Monad m => String -> WithHTML x m ()
onMouseDown = attr "onMouseDown"
-- ^The user depresses a mouse button.

--mousemove
onMouseMove :: Monad m => String -> WithHTML x m ()
onMouseMove = attr "onMouseMove"
-- ^The user moves the cursor.

--mouseout
onMouseOut :: Monad m => String -> WithHTML x m ()
onMouseOut = attr "onMouseOut"
-- ^The cursor leaves an area (client-side image map) or link from inside that
-- area or link. 

--mouseover
onMouseOver :: Monad m => String -> WithHTML x m ()
onMouseOver = attr "onMouseOver"
-- ^The cursor moves over an object or area from outside that object or area.

--mouseup
onMouseUp :: Monad m => String -> WithHTML x m ()
onMouseUp = attr "onMouseUp"
-- ^The user releases a mouse button.

--move
onMove :: Monad m => String -> WithHTML x m ()
onMove = attr "onMove"
-- ^The user or script moves a window or frame.

--reset
onReset :: Monad m => String -> WithHTML x m ()
onReset = attr "onReset"
-- ^The user resets a form (clicks a Reset button).

--resize
onResize :: Monad m => String -> WithHTML x m ()
onResize = attr "onResize"
-- ^The user or script resizes a window or frame.

--select
onSelect :: Monad m => String -> WithHTML x m ()
onSelect = attr "onSelect"
-- ^The user selects some of the text within a text or textarea field.

--submit
onSubmit :: Monad m => String -> WithHTML x m ()
onSubmit = attr "onSubmit"
-- ^The user submits a form.

--unload
onUnload :: Monad m => String -> WithHTML x m ()
onUnload = attr "onUnload"
-- ^The user exits a document.

-- specialized event handlers
-- |Redirect result of form submission to specific target. Attach to submission
-- button. 
toTarget :: Monad m => String -> WithHTML x m ()
toTarget t = onClick ("this.form.target='" ++ t ++ "'; this.form.submit(); return true")
