module HTMLWrapper (module HTMLMonad, module HTMLWrapper) where

import qualified Prelude
import HTMLMonad

-- |create a standard HTML page from a title string and body elements
standardPage :: (Prelude.Monad m) => Prelude.String -> WithHTML x m a -> WithHTML y m ()
standardPage ttl elems =
  htmlHeader ttl (body_S (h1_S (text ttl) ## elems))

-- |create a standard HTML page without heading from a title string and body elements
htmlHeader :: (Prelude.Monad m) => Prelude.String -> WithHTML x m a -> WithHTML y m ()
htmlHeader ttl elems =
  html_T (HTMLMonad.head_S (title_S (text ttl))
     ## elems
     ## attr_SS "xmlns" "http://www.w3.org/1999/xhtml")


