module WASHGenerator (preprocess) where {

import IO;

import WASHData ;
import Parsec hiding (try) ;
import qualified WASHParser ;
import qualified WASHExpression ;
import WASHFlags ;

-- import Trace;

preprocess :: FLAGS -> String -> String -> String -> IO ();
preprocess flags srcName dstName globalDefs = do {
    input <- readFile srcName;
    let { parsing = parse WASHParser.washfile srcName input };
    case parsing of {
        Left error -> ioError $ userError $ show error;
        Right washfile ->
        writeFile dstName (file flags globalDefs washfile "");
    
    };
};

file :: FLAGS -> String -> [CodeFrag] -> ShowS ;
file flags globalDefs fcode = 
  WASHExpression.code flags fcode .
  showString globalDefs .
  showString "\n"
  ;

imports ::  [String] -> String ;
imports is = concat $ map (\m -> "import " ++ m ++ ";\n") is ;


}
